﻿-- English Base Locale

local AddonID, QFind = ...
local Language = Inspect.System.Language()

QFind.Supported = {
	["English"] = true,
	["German"] = true,
	["French"] = true,
} 

if Language ~= "English" then
	if QFind.Supported[Language] then
		return
	end
end

QFind.Locale = {}

-- Special Case Conversion
QFind.Locale.PalLong = "Kingdom of Pelladane"
QFind.Locale.Pal = "Pelladane"

-- List output
QFind.Locale.Found = "Found %s possible quests for this zone, of which %s are Carnage Quests."
QFind.Locale.Missing = "Missing Quest: %s"
QFind.Locale.Log = "In Quest Log: %s"
QFind.Locale.Completed = "You have completed a total of %s quests here."
QFind.Locale.ZName = "Gathering Quest data for %s. Please wait..."
QFind.Locale.Summary = "You are missing %s quests, and have %s in your quest log."
QFind.Locale.Finished = '<font color="#FAFA09">You have completed all quests for this zone. Well done!'

-- Help
QFind.Locale.Help = "Type: /qfHelp to get a list of commmands"
QFind.Locale.HelpList = {
	Info = '<font color="#FAFA09">/qfind :<font color="#FFFFFF"> List missing quests for your current zone.',
	InfoFull = '<font color="#FAFA09">/qfind full :<font color="#FFFFFF"> Same as /qfind but include a brief summary of the quest.',
	Console = '<font color="#FAFA09">/qfsetting chat=Chat Tab Name :<font color="#FFFFFF"> Change the output chat tab.',
	Silent = '<font color="#FAFA09">/qfsetting silent=value :<font color="#FFFFFF"> True/False to turn Quest Finder\'s start up text off/on.',
}

-- Errors/Problems
QFind.Locale.Patient = "You have a search in progress. Please be patient."
QFind.Locale.NoQuest = "No quests can be found for this zone."
QFind.Locale.NoLoad = "Unable to load Zone data."
QFind.Locale.NoZone = "Unable to find your Zone location."
QFind.Locale.NoPlayer = "Unable to load player details, please try again."
QFind.Locale.SlowRift = "Rift data has yet to load fully."